
/*
 * main.c
 *	main routine and globals for reap utility.
 */


/* directory containing news articles */
#define NEWSDIR		"/usr/spool/news"


#include "reap.h"

/* linked lists for included and excluded file specs */
struct filspec
		*incl = NULL,
		*excl = NULL
;
char
		*scriptfile = "/usr/lib/news/reaplist",
		*progname,
		*newsdir = NEWSDIR
;
int
		verbose = 0,	/* verbosity flag */
		nodel = 0	/* do-not-unlink flag */
;
time_t
		age,		/* unlink files older than this	*/
		now		/* current time			*/
;



main(argc, argv)
int	argc;
char	*argv[];
{
	int		device,		/* dev.no. of disk containing newsdir */
			c,
			errflag = 0;
	long		wantblox;	/* desired free space */
	char		*p;
	static char	line[MAXLINE];
	FILE		*script;	/* file ptr for function script */
	struct stat	st;


/* parse args */
	progname = argv[0];

	while ( (c=getopt(argc,argv,"vnf:")) != EOF)
		switch(c) {
		    case 'n':
			++nodel;
			break;
		    case 'v':
			++verbose;
			break;
		    case 'f':
			scriptfile = optarg;
			break;
		    case '?':
			++errflag;
			break;
		}
	
	if (argc - optind != 1 ||
	    sscanf(argv[optind], "%ld", &wantblox) != 1 )
		++errflag;

	if (errflag) {
		fprintf (stderr,
		    "usage: %s [-v] [-n] [-f funclist] freeblocks\n", progname);
		exit (-1);
	}


/* stat newsdir to find the number of the device it's on */
	if (stat(newsdir, &st)) {
		fprintf (stderr, "%s: can't stat %s\n", progname, newsdir);
		exit (-1);
	}
	device = st.st_dev;

/* open function file for reading */
	if ( (script = fopen (scriptfile, "r")) == NULL) {
		fprintf (stderr, "%s: can't read %s\n", progname, scriptfile);
		exit (-1);
	}

/* when am i? */
	time (&now);

/* chdir to newsdir */
	chdir (newsdir);

/* main loop is right here ... process until goal reached or end of script */

	while (freeblox(device) < wantblox &&
	    (p = fgets (line, MAXLINE, script)) != NULL )
		parse (line);

	fclose (script);

/* return 0 if freespace goal was met at exit, 1 if not */
	exit (freeblox(device) >= wantblox ? 0 : 1);

} /* main() */

